<template lang="pug">
table.table.is-striped.is-hoverable
	thead
		tr
			th( v-for='({ label }, i) in columns' :key='i' ) {{ label }}
	tbody
		template( v-if='data.length' v-for='(item, y) in data' )
			tr( :key='y' :class='{ "no-button": !$scopedSlots.button }' )
				td( 
					v-for='({ field, label }, i) in columns' :key='i'
					:data-label='label')
					template( v-if='$scopedSlots[field]' )
						slot( :name='field' :item='item' :index='y' )
					template( v-else ) {{ item[field] }}
			tr.button( v-if='$scopedSlots.button' )
				td( :colspan='columns.length' )
					.button.is-flex.is-align-items-center.is-justify-content-center( @click='handleClick(item)' )
						slot( name="button" )
			tr.spacer( v-if='y !== data.length - 1' )
		tr( v-if='!data.length' )
			td.empty( :colspan='columns.length' )
				.is-flex.is-align-items-center.is-justify-content-flex-start
					p
						slot( v-if='$scopedSlots.empty' name="empty" )
						template( v-else ) {{ $t("default.no_data") }}
</template>

<script>
export default {
	props: {
		columns: {
			type: Array,
			default: () => []
		},
		data: {
			type: Array,
			default: () => []
		}
	},
	methods: {
		handleClick(item) {
			this.$emit("click", item)
		}
	}
}
</script>

<style lang="scss" scoped>
table {
	width: calc(100% + 1.5rem);
	margin: -.75rem;
}

thead,
tr.no-button:not(:last-of-type) td,
tr.button:not(:last-of-type) td {
	border-bottom: 1px solid rgba($color: #fff, $alpha: .03);
	@include max_tablet {
		border-bottom: unset;
	}
}

th, td {
	padding: .75rem;
}

th,
td::before {
	font-size: .625rem;
	font-weight: 800;
	text-transform: uppercase;
	color: $primary;
}

td {
	font-size: .875rem;
	font-weight: 400;
	.button {
		font-size: .875rem;
		font-weight: 700;
		text-align: center;
		width: calc(100% + 1.5rem);
		padding: .5rem;
		margin: -.75rem;
		margin-bottom: 0;
		background: rgba($color: #fff, $alpha: .06);
		border-radius: 6px;
		cursor: pointer;
		transition: background .2s ease-in-out;
		&:hover {
			background: rgba($color: #fff, $alpha: .1);
		}
	}
	&::v-deep {
		.has-text-weight-bold {
			font-weight: 700;
		}
	}
}

.empty {
	font-size: .875rem;
	font-weight: 500;
	color: #8E8E8E;
}

@include max_tablet {
	thead {
		display: none;
	}
	tr {
		&:not(.button):not(.spacer) {
			display: block;
			border: 1px solid #151717;
			border-radius: 8px;
			&:not(.no-button) {
				border-bottom-left-radius: 0;
				border-bottom-right-radius: 0;
				border-bottom: unset;
			}
			td {
				text-align: right;
				display: flex;
				align-items: center;
				justify-content: space-between;
				&::before {
					display: block;
					content: attr(data-label);
					text-align: left;
				}
				&+td {
					border-top: 1px solid #151717;
				}
			}
		}
		&.spacer {
			display: block;
			padding: .25rem;
		}
		&.button {
			td {
				display: block;
				padding: 0;
			}
			.button {
				border-top-left-radius: 0;
				border-top-right-radius: 0;
				width: calc(100% + 1.5px);
				margin: 0 -.75px;
			}
		}
	}
}
</style>